---
title: Learn Classes and Object by Building a Sudoku Solver
block: learn-classes-and-objects-by-building-a-sudoku-solver
superBlock: scientific-computing-with-python
---

## Learn Classes and Objects by Building a Sudoku Solver

Classes and objects are important programming concepts. These Object-Oriented Programming tools help developers to achieve code modularity, abstraction, and readability. They also promote reusability.

Sudoku Solver is a classical problem-solving game that requires logical thinking. It is a 9x9 grid puzzle where the objective is to fill each row, column, and 3x3 subgrid with numbers from 1 to 9 without repeating any number. The puzzle starts with some numbers already filled in, and the player must fill in the remaining cells to solve the puzzle.

In this Sudoku Solver project, you'll learn how to use classes and objects to build a Sudoku grid and to solve a Sudoku puzzle. The project leverages a `Board` class to represent the Sudoku grid and includes methods to check the validity of numbers, find empty cells, and solve the puzzle using a backtracking algorithm.
