---
id: 65774ae7c3eee66fe79b9459
title: Step 58
challengeType: 20
dashedName: step-58
---

# --description--

Now, you are going to test your function with another graph. Change `my_graph` into the following graph:

```py
{
    'A': [('B', 5), ('C', 3), ('E', 11)],
    'B': [('A', 5), ('C', 1), ('F', 2)],
    'C': [('A', 3), ('B', 1), ('D', 1), ('E', 5)],
    'D': [('C', 1), ('E', 9), ('F', 3)],
    'E': [('A', 11), ('C', 5), ('D', 9)],
    'F': [('B', 2), ('D', 3)]
}
```

# --hints--

You should modify `my_graph` into the provided graph.

```js
({ test: () => assert(runPython(`
    g = {
        'A': [('B', 5), ('C', 3), ('E', 11)],
        'B': [('A', 5), ('C', 1), ('F', 2)],
        'C': [('A', 3), ('B', 1), ('D', 1), ('E', 5)],
        'D': [('C',1 ), ('E', 9), ('F', 3)],
        'E': [('A', 11), ('C', 5), ('D', 9)],
        'F': [('B', 2), ('D', 3)]
    }
    my_graph == g
    
  `))
})
```

# --seed--

## --seed-contents--

```py
--fcc-editable-region--
my_graph = {
    'A': [('B', 3), ('D', 1)],
    'B': [('A', 3), ('C', 4)],
    'C': [('B', 4), ('D', 7)],
    'D': [('A', 1), ('C', 7)]
}
--fcc-editable-region--
def shortest_path(graph, start, target = ''):
    unvisited = list(graph)
    distances = {node: 0 if node == start else float('inf') for node in graph}
    paths = {node: [] for node in graph}
    paths[start].append(start)
    
    while unvisited:
        current = min(unvisited, key=distances.get)
        for node, distance in graph[current]:
            if distance + distances[current] < distances[node]:
                distances[node] = distance + distances[current]
                if paths[node] and paths[node][-1] == node:
                    paths[node] = paths[current][:]
                else:
                    paths[node].extend(paths[current])
                paths[node].append(node)
        unvisited.remove(current)

    targets_to_print = [target] if target else graph
    for node in targets_to_print:
        if node == start:
            continue
        print(f'\n{start}-{node} distance: {distances[node]}\nPath: {" -> ".join(paths[node])}')
    
    return distances, paths
shortest_path(my_graph, 'A')

```
