---
id: 665ee783d35cb68875c626d4
title: Step 28
challengeType: 20
dashedName: step-28
---

# --description--

Now, remove both the `print(lin_eq.solve())` and `print(lin_eq.analyze())` calls from your code.

# --hints--

You should remove both your `print(lin_eq.solve())` and `print(lin_eq.analyze())` calls.

```js
({ test: () => runPython(`
assert not _Node(_code).has_call("print(lin_eq.analyze())")
assert not _Node(_code).has_call("print(lin_eq.solve())")
`) })
```

# --seed--

## --seed-contents--

```py
from abc import ABC, abstractmethod

class Equation(ABC):
    degree: int
  
    def __init__(self, *args):
        if (self.degree + 1) != len(args):
            raise TypeError(
                f"'Equation' object takes {self.degree + 1} positional arguments but {len(args)} were given"
            )
        if any(not isinstance(arg, (int, float)) for arg in args):
            raise TypeError("Coefficients must be of type 'int' or 'float'")
        if args[0] == 0:
            raise ValueError("Highest degree coefficient must be different from zero")
        self.coefficients = {(len(args) - n - 1): arg for n, arg in enumerate(args)}

    def __init_subclass__(cls):
        if not hasattr(cls, "degree"):
            raise AttributeError(
                f"Cannot create '{cls.__name__}' class: missing required attribute 'degree'"
            )

    def __str__(self):
        terms = []
        for n, coefficient in self.coefficients.items():
            if not coefficient:
                continue
            if n == 0:
                terms.append(f'{coefficient:+}')
            elif n == 1:
                terms.append(f'{coefficient:+}x')                
        equation_string = ' '.join(terms) + ' = 0'
        return equation_string.strip('+')        
    
    @abstractmethod
    def solve(self):
        pass
        
    @abstractmethod
    def analyze(self):
        pass
        
class LinearEquation(Equation):
    degree = 1
    
    def solve(self):
        a, b = self.coefficients.values()
        x = -b / a
        return x

    def analyze(self):
        slope, intercept = self.coefficients.values()
        return {'slope': slope, 'intercept': intercept}


lin_eq = LinearEquation(2, 3)
print(lin_eq)
--fcc-editable-region--
print(lin_eq.solve())
print(lin_eq.analyze())
--fcc-editable-region--
```
