---
id: 66680ddfd0f8c76782923cb0
title: Step 22
challengeType: 20
dashedName: step-22
---

# --description--

The `norm()` method is returning the correct values, but there's still something you can improve: readability. 

The `vars()` built-in function takes an object as its argument and returns the `__dict__` attribute of that object.

Instead of directly accessing the `__dict__` attribute of `self`, modify the `norm` method to use the `vars()` function.

# --hints--

You should modify your `norm` method to use `vars(self)` instead of `self.__dict__`.

```js
({ test: () => assert(runPython(`_Node(_code).find_class("R2Vector").find_function("norm").has_return("sum(val**2 for val in vars(self).values())**0.5")`)) })
```

# --seed--

## --seed-contents--

```py

class R2Vector:
    def __init__(self, *, x, y):
        self.x = x
        self.y = y
--fcc-editable-region--
    def norm(self):
        return sum(val**2 for val in self.__dict__.values())**0.5
--fcc-editable-region--
    def __str__(self):
        return f'{self.x, self.y}'

class R3Vector(R2Vector):
    def __init__(self, *, x, y, z):
        super().__init__(x=x, y=y)
        self.z = z

v1 = R2Vector(x=2, y=3)
v2 = R3Vector(x=2, y=2, z=3)
print(v1.norm())
print(v2.norm())

```
