---
id: 619665c9abd72906f3ad30f9
title: Step 1
challengeType: 0
dashedName: step-1
demoType: onLoad
---

# --description--

You will be building a happy Flappy Penguin, and further exploring CSS transforms and animations in the process.

Begin with your basic HTML boilerplate. Include the `DOCTYPE` declaration, `html` element with a language set to English, the appropriate `meta` tags, a `head`, `body`, and `title` element. Also, link your stylesheet to the page.

# --hints--

Your code should have a `<!DOCTYPE html>` declaration.

```js
assert(code.match(/<!DOCTYPE html>/i));
```

Your code should have an `html` element.

```js
assert.equal(document.querySelectorAll('html')?.length, 1);
```

Your `html` element should have an opening tag with a `lang` attribute of `en`.

```js
assert(code.match(/<html\s+lang\s*=\s*('|")en\1\s*>/gi));
```

Your `html` element should have a closing tag.

```js
assert(code.match(/<\/html\s*>/gi));
```

Your code should have a `head` element within the `html` element.

```js
assert.equal(document.querySelectorAll('head')?.length, 1);
```

Your code should have a `body` element within the `html` element.

```js
assert.equal(document.querySelectorAll('body')?.length, 1);
```

Your `head` element should come before your `body` element.

```js
assert.equal(document.querySelector('body')?.previousElementSibling?.tagName, 'HEAD');
```

You should have two `meta` elements.

```js
const meta = document.querySelectorAll('meta');
assert.equal(meta?.length, 2);
```

One `meta` element should have a `name` set to `viewport`, and `content` set to `width=device-width, initial-scale=1.0`.

```js
const meta = [...document.querySelectorAll('meta')];
const target = meta?.find(m => m?.getAttribute('name') === 'viewport' && m?.getAttribute('content') === 'width=device-width, initial-scale=1.0' && !m?.getAttribute('charset'));
assert.exists(target);
```

The other `meta` element should have the `charset` attribute set to `UTF-8`.

```js
const meta = [...document.querySelectorAll('meta')];
const target = meta?.find(m => !m?.getAttribute('name') && !m?.getAttribute('content') && m?.getAttribute('charset')?.toLowerCase() === 'utf-8');
assert.exists(target);
```

Your code should have a `title` element.

```js
const title = document.querySelector('title');
assert.exists(title);
```

Your `title` should have some text.

```js
const title = document.querySelector('title');
assert.isAtLeast(title?.textContent?.length, 1);
```

Your code should have a `link` element.

```js
assert.exists(document.querySelector('link'));
```

Your `link` element should be within your `head` element.

```js
assert(code.match(/<head>[\w\W\s]*<link[\w\W\s]*\/?>[\w\W\s]*<\/head>/i));
```

Your `link` element should have a `rel` attribute with the value `stylesheet`.

```js
const link_element = document.querySelector('link');
const rel = link_element.getAttribute("rel");
assert.equal(rel, "stylesheet");
```

Your `link` element should have an `href` attribute with the value `styles.css`.

```js
const link = document.querySelector('link');
assert.equal(link.dataset.href, "styles.css");
```

# --seed--

## --seed-contents--

```html
--fcc-editable-region--

--fcc-editable-region--
```

```css

```
