---
id: 5dfb6a35eacea3f48c6300b4
title: Step 24
challengeType: 0
dashedName: step-24
---

# --description--

A figure caption (`figcaption`) element is used to add a caption to describe the image contained within the `figure` element. 

Here is an example of a `figcaption` element with the caption of `A cute cat`:

```html
<figure>
  <img src="image.jpg" alt="A description of the image">
  <figcaption>A cute cat</figcaption>
</figure>
```

After the image nested in the `figure` element, add a `figcaption` element with text set to:

`Cats love lasagna.`

# --hints--

Your `figcaption` element should have an opening tag. Opening tags have the following syntax: `<elementName>`.

```js
assert(document.querySelector('figcaption'));
```

Your `figcaption` element should have a closing tag. Closing tags have a `/` just after the `<` character.

```js
assert(code.match(/<\/figcaption\>/));
```

The `figcaption` element should be nested in the `figure` element.

```js
assert(
  document.querySelector('figure > figcaption') &&
    document.querySelector('figure > figcaption')
);
```

The lasagna `img` element should be nested in the `figure` element.

```js
assert(
  document.querySelector('figure > img') &&
    document.querySelector('figure > img').getAttribute('src').toLowerCase() ===
      'https://cdn.freecodecamp.org/curriculum/cat-photo-app/lasagna.jpg'
);
```

The `figcaption` element nested in the `figure` element should be below the `img` element. You have them in the wrong order.

```js
assert(
  document.querySelector('figcaption').previousElementSibling.nodeName === 'IMG'
);
```

Your `figcaption` element's text should be `Cats love lasagna.` You have either omitted the text or have a typo.

```js
assert(
  document.querySelector('figcaption').innerText.match(/Cats love lasagna.?$/i)
);
```

# --seed--

## --seed-contents--

```html
<html>
  <body>
    <main>
      <h1>CatPhotoApp</h1>
      <section>
        <h2>Cat Photos</h2>
        <!-- TODO: Add link to cat photos -->
        <p>See more <a target="_blank" href="https://freecatphotoapp.com">cat photos</a> in our gallery.</p>
        <a href="https://freecatphotoapp.com"><img src="https://cdn.freecodecamp.org/curriculum/cat-photo-app/relaxing-cat.jpg" alt="A cute orange cat lying on its back."></a>
      </section>
      <section>
        <h2>Cat Lists</h2>
        <h3>Things cats love:</h3>
        <ul>
          <li>cat nip</li>
          <li>laser pointers</li>
          <li>lasagna</li>
        </ul>
--fcc-editable-region--
        <figure>
          <img src="https://cdn.freecodecamp.org/curriculum/cat-photo-app/lasagna.jpg" alt="A slice of lasagna on a plate.">
          
        </figure>
--fcc-editable-region--
      </section>
    </main>
  </body>
</html>
```

