---
id: 642335d232d7690b2d67dbaf
title: Step 28
challengeType: 0
dashedName: step-28
---

# --description--

You still aren't matching `free money` yet, because you need to match the end of the string as well.

Like the `^` anchor, you can use the `$` anchor to match the end of the string.

Update your regular expression to match either the end of the string or a space, like you did for the beginning of the string.

# --hints--

Your `freeRegex` should use a second non-capturing group.

```js
assert.lengthOf(freeRegex.source.match(/\(\?:/g), 2);
```

Your `freeRegex` should use a non-capturing group to match `\s` or `$`.

```js
assert.match(freeRegex.source, /\(\?:(\$\|\\s|\\s\|\$)\)/);
```

Your `freeRegex` should match `it's free money time`.

```js
assert.match("it's free money time", freeRegex);
```

Your `freeRegex` should match `free money time`.

```js
assert.match('free money time', freeRegex);
```

Your `freeRegex` should match `it's free money`.

```js
assert.match("it's free money", freeRegex);
```

Your `freeRegex` should match `free money`.

```js
assert.match('free money', freeRegex);
```

Your `freeRegex` should not match `hands-free money time`.

```js
assert.notMatch('hands-free money', freeRegex);
```

Your `freeRegex` should not match `free money-management`.

```js
assert.notMatch('free money-management', freeRegex);
```

# --seed--

## --seed-contents--

```html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width" />
    <title>Learn Regular Expressions by Building a Spam Filter</title>
    <link rel="stylesheet" href="styles.css" />
  </head>

  <body>
    <header class="main-text">
      <h1 class="title">Is this Spam?</h1>
      <p class="description">
        Enter a phrase to check if it would be marked as spam or not.
      </p>
    </header>

    <main>
      <label class="message-label" for="message-input">Message: </label>
      <textarea
        placeholder="Enter message here"
        value=""
        type="text"
        name="message"
        id="message-input"
        rows="10"
        cols="40"
      ></textarea>
      <button class="btn" id="check-message-btn" type="button">
        Check message
      </button>
      <p id="result"></p>
    </main>

    <footer class="footer">&copy; freeCodeCamp</footer>
    <script src="./script.js"></script>
  </body>
</html>
```

```css
*,
*::before,
*::after {
  box-sizing: border-box;
  margin: 0;
  padding: 0;
}

:root {
  --dark-grey: #1b1b32;
  --light-grey: #f5f6f7;
  --golden-yellow: #fecc4c;
  --yellow: #ffcc4c;
  --gold: #feac32;
  --orange: #ffac33;
  --dark-orange: #f89808;
}

body {
  background-color: var(--dark-grey);
  color: var(--light-grey);
}

body,
#message-input:placeholder-shown {
  text-align: center;
}

textarea {
  max-width: 90%;
}

.main-text {
  margin: 25px 0;
}

.title {
  font-size: 2.5rem;
}

.description {
  margin-top: 15px;
  font-size: 1.4rem;
}

.message-label {
  display: block;
  margin-bottom: 20px;
  font-size: 1.5rem;
}

#message-input:placeholder-shown,
textarea {
  font-size: 1.1rem;
}

.btn {
  display: block;
  cursor: pointer;
  width: 200px;
  margin: 10px auto;
  color: var(--dark-grey);
  background-color: var(--gold);
  background-image: linear-gradient(var(--golden-yellow), var(--orange));
  border-color: var(--gold);
  border-width: 3px;
}

.btn:hover {
  background-image: linear-gradient(var(--yellow), var(--dark-orange));
}

#result {
  font-size: 2rem;
  margin: 20px 0;
}

.footer {
  margin-top: 10px;
}
```

```js
const messageInput = document.getElementById("message-input");
const result = document.getElementById("result");
const checkMessageButton = document.getElementById("check-message-btn");

const helpRegex = /please help|assist me/i;
const dollarRegex = /[0-9]+\s*(?:hundred|thousand|million|billion)?\s+dollars/i;
--fcc-editable-region--
const freeRegex = /(?:^|\s)fr[e3][e3] m[o0]n[e3]y\s/i;
--fcc-editable-region--

const denyList = [helpRegex, dollarRegex, freeRegex];

const isSpam = (msg) => denyList.some((regex) => regex.test(msg));

checkMessageButton.addEventListener("click", () => {
  if (messageInput.value === "") {
    alert("Please enter a message.");
    return;
  }

  result.textContent = isSpam(messageInput.value)
    ? "Oh no! This looks like a spam message."
    : "This message does not seem to contain any spam.";
  messageInput.value = "";
});
```
