---
id: 66a9cd4ffa48cf1ef7333640
title: Step 12
challengeType: 0
dashedName: step-12
---

# --description--

Your table is almost complete but there is one last thing to add.

It would be nice if the `td` element used for the `Average Grade` would span across two columns instead of just one.

To do this, you can use the <dfn>colspan</dfn> attribute on the `td` element. 

The `colspan` attribute specifies the number of columns a cell should span.

Here is an example of using the `colspan` attribute for a sports table:

```html
<tr>
  <td colspan="3">Total Points</td>
</tr>
```

Inside the opening `td` tag, add the `colspan` attribute and set it to `"2"`.

And with that change, your table is complete!

# --hints--

You should not alter the content of the existing `td` element.

```js
assert.strictEqual(document.querySelector('tfoot tr td:first-child').textContent, 'Average Grade');
```

Your `td` element should have a `colspan` attribute.

```js
assert.isTrue(document.querySelector('tfoot tr td:first-child').hasAttribute('colspan'));
```

Your `td` element should have a `colspan` attribute with a value of `"2"`.

```js
assert.strictEqual(document.querySelector('tfoot tr td:first-child').getAttribute('colspan'), '2');
```

# --seed--

## --seed-contents--

```html
<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Calculus Final Exams Table</title>
    <meta charset="UTF-8" />
  </head>
  <body>
    <table>
      <caption>
        Calculus Final Exam Grades
      </caption>

      <thead>     
        <tr>
          <th>Last Name</th>
          <th>First Name</th>
          <th>Grade</th>
        </tr>
      </thead>

      <tbody>
        <tr>
          <td>Davis</td>
          <td>Alex</td>
          <td>54</td>
        </tr>

        <tr>
          <td>Doe</td>
          <td>Samantha</td>
          <td>92</td>
        </tr>

        <tr>
          <td>Rodriguez</td>
          <td>Marcus</td>
          <td>88</td>
        </tr>

        <tr>
          <td>Thompson</td>
          <td>Jane</td>
          <td>77</td>
        </tr>

        <tr>
          <td>Williams</td>
          <td>Natalie</td>
          <td>83</td>
        </tr>
      </tbody>

      <tfoot>
        <tr>
          --fcc-editable-region--
          <td>Average Grade</td>
          --fcc-editable-region--
          <td>78.8</td>
        </tr>
      </tfoot>
    </table>
  </body>
</html>
```

# --solutions--

```html
<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Calculus Final Exams Table</title>
    <meta charset="UTF-8" />
  </head>
  <body>
    <table>
      <caption>
        Calculus Final Exam Grades
      </caption>

      <thead>     
        <tr>
          <th>Last Name</th>
          <th>First Name</th>
          <th>Grade</th>
        </tr>
      </thead>

      <tbody>
        <tr>
          <td>Davis</td>
          <td>Alex</td>
          <td>54</td>
        </tr>

        <tr>
          <td>Doe</td>
          <td>Samantha</td>
          <td>92</td>
        </tr>

        <tr>
          <td>Rodriguez</td>
          <td>Marcus</td>
          <td>88</td>
        </tr>

        <tr>
          <td>Thompson</td>
          <td>Jane</td>
          <td>77</td>
        </tr>

        <tr>
          <td>Williams</td>
          <td>Natalie</td>
          <td>83</td>
        </tr>
      </tbody>

      <tfoot>
        <tr>
          <td colspan="2">Average Grade</td>
          <td>78.8</td>
        </tr>
      </tfoot>
    </table>
  </body>
</html>
```
