---
id: 66a83fec026a7a4631e084d2
title: Step 8
challengeType: 0
dashedName: step-8
---

# --description--

When working with `fieldset` elements, it is common to use a caption to describe the group of inputs. You can use the <dfn>legend</dfn> element for this.

Here is an example of using a `legend` element:

```html
<form action="/example-url">
  <fieldset>
    <legend>Personal Information</legend>
    <!-- inputs go inside here-->
  </fieldset>
</form>
```

Inside your `fieldset` element, add a `legend` element with the text `Personal Information`.

# --hints--

You should have an opening `legend` tag.

```js
assert.match(code, /<legend>/);
```

You should have a closing `legend` tag.

```js
assert.match(code, /<\/legend>/);
```

Your `legend` element should be inside the `fieldset` element.

```js
assert.isNotNull(document.querySelector('fieldset legend'));
```

Your `legend` element should contain the text `Personal Information`.

```js
const legend = document.querySelector('fieldset legend');
assert.strictEqual(legend.innerText, 'Personal Information');
```

# --seed--

## --seed-contents--

```html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Hotel Feedback Form</title>
  </head>
  <body>
    <header>
      <h1>Hotel Feedback Form</h1>
      <p>
        Thank you for staying with us. Please provide feedback on your recent
        stay.
      </p>
    </header>
    <main>
--fcc-editable-region--
      <form method="POST" action="https://hotel-feedback.freecodecamp.org">
        <fieldset>

        </fieldset>
      </form>
--fcc-editable-region--
    </main>
  </body>
</html>
```
