---
id: 66a9521bc70162712caf118d
title: Step 18
challengeType: 0
dashedName: step-18
---

# --description--

If you want users to select one option from a list of options, you can use a set of radio buttons.

Here is an example of two radio buttons:

```html
<input type="radio" id="yes" name="first-time">
<label for="yes">Yes</label>
<input type="radio" id="no" name="first-time">
<label for="no">No</label>
```

In this example, the radio buttons are grouped together by using the same `name` attribute value. This means that only one radio button can be selected at a time.

Below your `legend` element, add a `label` element with the text `Yes` and a `for` attribute set to `"yes-option"`.

Below your `label` element, add a `radio` button with the `id` set to `"yes-option"`, and the `name` attribute set to `"hotel-stay"`.

# --hints--

You should have a `label` element inside your `fieldset` element.

```js
assert(document.querySelector('fieldset:nth-of-type(2) label'));
```

Your `label` element should have a `for` attribute set to `"yes-option"`.

```js
assert.strictEqual(document.querySelector('fieldset:nth-of-type(2) label').htmlFor, 'yes-option');
```

Your `label` element should have the text `Yes`.

```js
assert.strictEqual(document.querySelector('fieldset:nth-of-type(2) label').innerText, 'Yes');
```

You should have a `radio` button inside your `fieldset` element.

```js
assert(document.querySelector('fieldset:nth-of-type(2) input[type="radio"]'));
```

Your `radio` button should have an `id` attribute set to `"yes-option"`.

```js
assert.strictEqual(document.querySelector('fieldset:nth-of-type(2) input[type="radio"]').id, 'yes-option');
```

Your `radio` button should have a `name` attribute set to `"hotel-stay"`.

```js
assert.strictEqual(document.querySelector('fieldset:nth-of-type(2) input[type="radio"]').name, 'hotel-stay');
```

# --seed--

## --seed-contents--

```html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Hotel Feedback Form</title>
  </head>
  <body>
    <header>
      <h1>Hotel Feedback Form</h1>
      <p>
        Thank you for staying with us. Please provide feedback on your recent
        stay.
      </p>
    </header>
    <main>
      <form method="POST" action="https://hotel-feedback.freecodecamp.org">
        <fieldset>
          <legend>Personal Information</legend>
          <label for="full-name">Name*:</label>
          <input type="text" id="full-name" name="name" placeholder="Ex. John Doe" required>

          <label for="email">Email address*:</label>
          <input
            placeholder="example@email.com"
            required
            id="email"
            type="email"
            name="email"
          />
          <label for="age">Age(optional):</label>
          <input type="number" name="age" id="age" min="3" max="100" />
        </fieldset>
        --fcc-editable-region--
        <fieldset>
          <legend>Was this your first time at our hotel?</legend>

        </fieldset>
        --fcc-editable-region--
      </form>
    </main>
  </body>
</html>
```
