---
id: 66a95d0eff8168747805f1f3
title: Step 21
challengeType: 0
dashedName: step-21
---

# --description--

When you want a user to select multiple options from a list, you can use checkboxes. 

Here is an example of how to work with checkboxes dealing with food options:

```html
<fieldset>
  <legend>Food Options</legend>
  <label for="pizza">Pizza</label>
  <input type="checkbox" id="pizza" name="food" value="pizza">
  <label for="burger">Burger</label>
  <input type="checkbox" id="burger" name="food" value="burger">
</fieldset>
```

The `value` attribute is used to specify the value that will be sent to the server when the form is submitted.

Below your `legend` element, add a `label` element with the text of `Social Media Ads`. The `for` attribute should be set to `"ads"`.

Below your `label` element, add a checkbox input with the `id`, `name` and `value` attributes set to `"ads"`.

# --hints--

You should have a `label` element inside your `fieldset`.

```js
assert(document.querySelector("fieldset:nth-of-type(3) label"));
```

Your `label` element should have the text of `Social Media Ads`.

```js
assert.strictEqual(document.querySelector("fieldset:nth-of-type(3) label").textContent, "Social Media Ads");
```

Your `label` element should have a `for` attribute set to `"ads"`.

```js
assert.strictEqual(document.querySelector("fieldset:nth-of-type(3) label").getAttribute("for"), "ads");
```

You should have a checkbox `input` inside your `fieldset`.

```js
const inputElement = document.querySelector("fieldset:nth-of-type(3) input[type='checkbox']");
assert.strictEqual(inputElement.parentElement.tagName, "FIELDSET");
```

Your checkbox should have an `id` attribute set to `"ads"`.

```js
assert.strictEqual(document.querySelector("fieldset:nth-of-type(3) input[type='checkbox']").id, "ads");
```

Your checkbox should have a `name` attribute set to `"ads"`.

```js
assert.strictEqual(document.querySelector("fieldset:nth-of-type(3) input[type='checkbox']").name, "ads");
```

Your checkbox should have a `value` attribute set to `"ads"`.

```js
assert.strictEqual(document.querySelector("fieldset:nth-of-type(3) input[type='checkbox']").value, "ads");
```

# --seed--

## --seed-contents--

```html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Hotel Feedback Form</title>
  </head>
  <body>
    <header>
      <h1>Hotel Feedback Form</h1>
      <p>
        Thank you for staying with us. Please provide feedback on your recent
        stay.
      </p>
    </header>
    <main>
      <form method="POST" action="https://hotel-feedback.freecodecamp.org">
        <fieldset>
          <legend>Personal Information</legend>
          <label for="full-name">Name*:</label>
          <input type="text" id="full-name" name="name" placeholder="Ex. John Doe" required>

          <label for="email">Email address*:</label>
          <input
            placeholder="example@email.com"
            required
            id="email"
            type="email"
            name="email"
          />
          <label for="age">Age(optional):</label>
          <input type="number" name="age" id="age" min="3" max="100" />
        </fieldset>

        <fieldset>
          <legend>Was this your first time at our hotel?</legend>
          <label for="yes-option">Yes</label>
          <input id="yes-option" type="radio" name="hotel-stay" />
          <label for="no-option">No</label>
          <input id="no-option" type="radio" name="hotel-stay" />
        </fieldset>

        --fcc-editable-region--
        <fieldset>
          <legend>
            Why did you choose to stay at our hotel? (Check all that apply)
          </legend>

        </fieldset>
        --fcc-editable-region--
      </form>
    </main>
  </body>
</html>
```
