---
id: 66a96b01f33ef178dfca9e42
title: Step 27
challengeType: 0
dashedName: step-27
---

# --description--

When you want users to make selections from a dropdown menu, you can use the <dfn>select</dfn> and <dfn>option</dfn> elements. 

Here is an example of using the `select` and `option` elements to create a dropdown for different cities:

```html
<label for="city">Choose a City: </label>
<select id="city" name="city">
  <option value="new-york">New York</option>
  <option value="los-angeles">Los Angeles</option>
  <option value="chicago">Chicago</option>
  <option value="miami">Miami</option>
</select>
```

Start by adding a `select` element with the `name` and `id` attributes set to `"service"`.

# --hints--

Your `fieldset` should have a `select` element.

```js
assert(document.querySelector('fieldset:nth-of-type(4) select'));
```

Your `select` element should have a `name` attribute set to `"service"`.

```js
assert(document.querySelector('select[name="service"]'));
```

Your `select` element should have an `id` attribute set to `"service"`.

```js
assert(document.querySelector('select[id="service"]'));
```

# --seed--

## --seed-contents--

```html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Hotel Feedback Form</title>
  </head>
  <body>
    <header>
      <h1>Hotel Feedback Form</h1>
      <p>
        Thank you for staying with us. Please provide feedback on your recent
        stay.
      </p>
    </header>
    <main>
      <form method="POST" action="https://hotel-feedback.freecodecamp.org">
        <fieldset>
          <legend>Personal Information</legend>
          <label for="full-name">Name*:</label>
          <input type="text" id="full-name" name="name" placeholder="Ex. John Doe" required>

          <label for="email">Email address*:</label>
          <input
            placeholder="example@email.com"
            required
            id="email"
            type="email"
            name="email"
          />
          <label for="age">Age(optional):</label>
          <input type="number" name="age" id="age" min="3" max="100" />
        </fieldset>

        <fieldset>
          <legend>Was this your first time at our hotel?</legend>
          <label for="yes-option">Yes</label>
          <input id="yes-option" type="radio" name="hotel-stay" />
          <label for="no-option">No</label>
          <input id="no-option" type="radio" name="hotel-stay" />
        </fieldset>

        <fieldset>
          <legend>
            Why did you choose to stay at our hotel? (Check all that apply)
          </legend>

          <label for="ads">Social Media Ads</label>
          <input type="checkbox" id="ads" name="ads" value="ads" />

          <label for="recommendation">Personal Recommendation</label>
          <input
            type="checkbox"
            id="recommendation"
            name="recommendation"
            value="recommendation"
          />

          <label for="location">Location</label>
          <input type="checkbox" id="location" name="location" value="location" />

          <label for="reputation">Reputation</label>
          <input
            checked
            type="checkbox"
            id="reputation"
            name="reputation"
            value="reputation"
          />

          <label for="price">Price</label>
          <input type="checkbox" id="price" name="price" value="price" />
        </fieldset>

        <fieldset>
          <legend>Ratings</legend>

          <label for="service">How was the service?</label>

          --fcc-editable-region--

          --fcc-editable-region--
        </fieldset>
      </form>
    </main>
  </body>
</html>
```
