---
id: 66a9824ac5d9f77ec304969f
title: Step 33
challengeType: 0
dashedName: step-33
---

# --description--

If you want users to have more space to write their comments, you can use a <dfn>textarea</dfn> element. 

The `textarea` element is a multi-line text input control that allows users to enter text that is longer than a single line. It can be used to create a comment box, a message input, or other text input that requires multiple lines.

Here's an example of a `textarea` element:

```html
<textarea id="comments" name="comments" rows="4" cols="50"></textarea>
```

The `rows` attribute is used to specify the visible height of the `textarea`, and the `cols` attribute is used to specify the visible width of the `textarea`.

Below your `label` element, add a `textarea` element. In the next step, you will add the necessary attributes.

# --hints--

You should have a `textarea` element inside your form.

```js
assert(document.querySelector('form textarea'));
```

# --seed--

## --seed-contents--

```html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Hotel Feedback Form</title>
  </head>
  <body>
    <header>
      <h1>Hotel Feedback Form</h1>
      <p>
        Thank you for staying with us. Please provide feedback on your recent
        stay.
      </p>
    </header>
    <main>
      <form method="POST" action="https://hotel-feedback.freecodecamp.org">
        <fieldset>
          <legend>Personal Information</legend>
          <label for="full-name">Name*:</label>
          <input type="text" id="full-name" name="name" placeholder="Ex. John Doe" required>

          <label for="email">Email address*:</label>
          <input
            placeholder="example@email.com"
            required
            id="email"
            type="email"
            name="email"
          />
          <label for="age">Age(optional):</label>
          <input type="number" name="age" id="age" min="3" max="100" />
        </fieldset>

        <fieldset>
          <legend>Was this your first time at our hotel?</legend>
          <label for="yes-option">Yes</label>
          <input id="yes-option" type="radio" name="hotel-stay" />
          <label for="no-option">No</label>
          <input id="no-option" type="radio" name="hotel-stay" />
        </fieldset>

        <fieldset>
          <legend>
            Why did you choose to stay at our hotel? (Check all that apply)
          </legend>

          <label for="ads">Social Media Ads</label>
          <input type="checkbox" id="ads" name="ads" value="ads" />

          <label for="recommendation">Personal Recommendation</label>
          <input
            type="checkbox"
            id="recommendation"
            name="recommendation"
            value="recommendation"
          />

          <label for="location">Location</label>
          <input type="checkbox" id="location" name="location" value="location" />

          <label for="reputation">Reputation</label>
          <input
            checked
            type="checkbox"
            id="reputation"
            name="reputation"
            value="reputation"
          />

          <label for="price">Price</label>
          <input type="checkbox" id="price" name="price" value="price" />
        </fieldset>

        <fieldset>
          <legend>Ratings</legend>

          <label for="service">How was the service?</label>

          <select name="service" id="service">
            <option value="poor">Poor</option>
            <option value="satisfactory">Satisfactory</option>
            <option value="good">Good</option>
            <option value="very-good">Very Good</option>
            <option selected value="excellent">Excellent</option>
          </select>

          <label for="food">How was the food?</label>

          <select name="food" id="food">
            <option value="poor">Poor</option>
            <option value="satisfactory">Satisfactory</option>
            <option value="good">Good</option>
            <option value="very-good">Very Good</option>
            <option selected value="excellent">Excellent</option>
          </select>
        </fieldset>

        <label for="comments">Other Comments?</label>

        --fcc-editable-region--

        --fcc-editable-region--
      </form>
    </main>
  </body>
</html>
```
